# Contracts

The EVM Compatible smart contracts underpinning the infrastructure offer the transactional and integrity layer of the functionality.

> Note: These contracts are under development, use at your own risk.

<table data-full-width="true"><thead><tr><th></th><th width="122">GOERLI</th><th width="119">SEPOLIA</th><th width="163">Hedera Testnet</th><th width="148">Base Goerli</th><th>Gas*</th></tr></thead><tbody><tr><td>Wallet</td><td><a href="https://goerli.etherscan.io/address/0x5F4f89bd3B61740F2E8264FE9ff8e2Cdf295B2bF">0x5F4...</a></td><td><a href="https://sepolia.etherscan.io/address/0x4b8Dfd5BdE2907c9b45E5C392421DE5B31E88313">0x4b8...</a></td><td><a href="https://hashscan.io/testnet/contract/0.0.14163364">0x756...</a></td><td><a href="https://goerli.basescan.org/address/0xF972E1A76F08c377bF0DB8ed52a231EE99bD0b41">0xF97...</a></td><td>1,162,239</td></tr><tr><td>Vault</td><td><a href="https://goerli.etherscan.io/address/0x4C1fcce4474CEA690Af57f08eE189CaC4f2e4721">0x4C1...</a></td><td><a href="https://sepolia.etherscan.io/address/0x38Ad327aDF4c763C0686ED8DBc6fa45c7dAb29AE">0x38A...</a></td><td><a href="https://hashscan.io/testnet/contract/0.0.14163367">0xd80...</a></td><td><a href="https://goerli.basescan.org/address/0x9d68228C8E043630041Cf08f911D2EC329390555">0x9d6...</a></td><td>5,041,627</td></tr><tr><td>Deal</td><td><a href="https://goerli.etherscan.io/address/0xe8Fb759ABA61091700eBF85F35b866c751Ba6DD6">0xe8F...</a></td><td><a href="https://sepolia.etherscan.io/address/0x52329a088c7d8EBd368fe67a6d3966E3BB42A5BB">0x523...</a></td><td><a href="https://hashscan.io/testnet/contract/0.0.14163369">0x38c...</a></td><td><a href="https://goerli.basescan.org/address/0xFCC3B351310c2E16035E2126cee14175F5350c91">0xFCC...</a></td><td>4,328,511</td></tr><tr><td>Oracle</td><td><a href="https://goerli.etherscan.io/address/0xa946D99b5dDdd21688AfBBF16c196052c93577Ba">0xa94...</a></td><td><a href="https://sepolia.etherscan.io/address/0x8b2a145b8ccdAfC79DDD3D6bE56Bd513a1e0AA49">0x8b2...</a></td><td><a href="https://hashscan.io/testnet/contract/0.0.14163370">0xeEB...</a></td><td><a href="https://goerli.basescan.org/address/0xbbf1D9AE5919E25567e17FE0e5187f35F6F562a6">0xbbf...</a></td><td>693,393</td></tr><tr><td>ServiceBus</td><td><a href="https://goerli.etherscan.io/address/0x9894CE6BB4dFdE24ACD6276D9CF4Fbd20d67d272">0x989...</a></td><td><a href="https://sepolia.etherscan.io/address/0x5A95e579944a53370c51760A2db3dF6b96b866F1">0x5A9...</a></td><td><a href="https://hashscan.io/testnet/contract/0.0.14195226">0xCe0...</a></td><td><a href="https://goerli.basescan.org/address/0x24A4d3335f88e59FA672093226D666B1D9CAACAf">0x24A...</a></td><td>735,119</td></tr></tbody></table>

*\*Deployment Gas fees*

#### Method Costs

These are the costs measured on the Goerli and Sepolia testnets. The gas limits are hardcoded for Hedera since the network doesn't have a gas estimation function currently.

|        | Methods            | Approx Gas | Gas Limit |
| ------ | ------------------ | ---------- | --------- |
| Wallet | registerKeys       | 684,397    | 700,000   |
| Wallet | setValue           | 137,643    | 200,000   |
| Wallet | setFileIndex       | 90,313     | 100,000   |
| Wallet | setCredentialIndex | 90,313     | 100,000   |
| Vault  | deposit            | 552,191    | 600,000   |
| Vault  | withdraw           | 374,927    | 400,000   |
| Vault  | createRequest      | 1,152,414  | 1,200,000 |
| Vault  | acceptRequest      | 618,821    | 650,000   |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.notcentralised.com/contracts.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
